% this code is used for concatenating the 47 task beta maps
% author Meiling Li, Apri,2017

clear,clc
%% add workbenck
addpath(genpath ('/zfs/musc/Xiaoxuan/Software/workbench'));
addpath(genpath('/zfs/musc/Xiaoxuan/Scripts/CIFTIMatlabReaderWriter_Xpeng'));

%% setpath
TaskPath = '/zfs/musc/Meiling/HCP/TaskActivation';
OutPath = TaskPath;

SIDs = textread('/zfs/musc/Meiling/HCP/Lists/HCP_680.txt','%s');

% Load example data
[cifti_template,BM] = open_wbfile('/zfs/musc/Xiaoxuan/Scripts/CIFTIMatlabReaderWriter_Xpeng/example.dtseries.nii');
DataIndex = [BM{1}.DataIndices(:); BM{2}.DataIndices(:)];

%% Set task name and task contrast
TaskName_range = {'MOTOR';'LANGUAGE';'WM';'GAMBLING';'RELATIONAL';'SOCIAL';'EMOTION'};

%% load task activations, beta values
for s = 1:length(SIDs)
    s
    sub = SIDs{s};
    k = 0;
    for t = 1:length(TaskName_range)
        TaskName = TaskName_range{t};
        TaskContrasts = textread(['/zfs/musc/Meiling/HCP/Lists/TASK_copes/tfMRI_' TaskName '_Selected.txt'],'%s');  
     
         for cope_i = 1:length(TaskContrasts) 
             k = k+1;
             TaskContrast = TaskContrasts{cope_i};
             cifti = open_wbfile([TaskPath '/' sub '/MNINonLinear/Results/tfMRI_' TaskName '/tfMRI_' TaskName '_hp200_s4_level2.feat/GrayordinatesStats/' TaskContrast '.feat/cope1.dtseries.nii']);
             Data = cifti.cdata; % 91282*1
             SurfData = Data(DataIndex);
             BetaMaps(:,k) = SurfData; % 59412*47
         end
    end
               

       save([OutPath '/' sub '/Concanated_47BetaMaps_nozscore.mat'],'BetaMaps');
       clear BetaMaps
end

