% Calculate the degree of negative connecitivity (TASK) at vertex-level
% author Meiling Li, Apri,2017

clear,clc
%% add workbenck
addpath(genpath ('/zfs/musc/Xiaoxuan/Software/workbench'));
addpath(genpath('/zfs/musc/Xiaoxuan/Scripts/CIFTIMatlabReaderWriter_Xpeng'));

InPath = '/zfs/musc/Meiling/HCP/TaskActivation';

OutPath = '/zfs/musc/Meiling/HCP/NegCount/TASK';mkdir([OutPath]);
SIDs = textread('/zfs/musc/Meiling/HCP/Lists/HCP_680.txt','%s');


%% Load 1483 ROIs(vertices) uniformly distributed on surface
cifti = open_wbfile('/zfs/musc/Meiling/HCP/Template/fslr_downsample_900mesh_parcellation.dscalar.nii');
labels = cifti.cdata;
ROINums = max(labels);


%% Calculate functional connectivity profile for each vertex
rth = 0;
NegcountMap = zeros(59412,1);
for s = 1:length(SIDs)
    s
    sub = SIDs{s};
  
    load([InPath '/' sub '/Concanated_47BetaMaps_nozscore.mat']);
    BgSig = BetaMaps; % 59412*47

    ROI_sig = zeros(ROINums,47);
    
    for roi = 1:ROINums
        index = find(labels==roi);
        ROI_sig(roi,:) = mean(BgSig(index,:),1);
    end
    ConnectProfile = corr(BgSig',ROI_sig');
    save([OutPath '/' sub '_connectProfile.mat'],'ConnectProfile');
     
    
    ConnectProfile(ConnectProfile>rth) = 0;
    ConnectProfile(ConnectProfile<rth) = 1;
    NegcountMap_s = sum(ConnectProfile,2);
    NegcountMap = NegcountMap+NegcountMap_s;
    clear ConnectProfile
end
m_NegcountMap = NegcountMap./s;
cifti_template = open_wbfile('/zfs/musc/Xiaoxuan/Scripts/CIFTIMatlabReaderWriter_Xpeng/example.dscalar.nii');
cifti_template.cdata = m_NegcountMap;
ciftisave(cifti_template,[OutPath '/Negcount_th' num2str(rth) '.dscalar.nii']);

%% normalization
task = m_NegcountMap;
z_task = (task-min(task))/(max(task)-min(task));
cifti_template.cdata = z_task;
ciftisave(cifti_template,[OutPath '/Norm_Negcount_th' num2str(rth) '.dscalar.nii']);
